/*
cladcode.c

implements cladistic coding of gene order data
see Cladistics, 18 (2002): 526-536;
however, for LINEAR chromosomes.
|sign


*** INCOMPLETE /***
*/  
#include "libmatrix.h"

void
main(void){

	iMatrix data, codes, state, polarity, presence;
	cMatrix neighbors;
	int ntax, ngen

	// read data: data matrix are rows of gene numbers, missing are coded as 0 at the end of
	// sequence, so that row has exactly ngen elements! Rows are gene orders for individual taxa.

	readheader(ntax, ngen);
	allocimat( *data, ntax, ngen);
//	readimat(*data);

	// for every gene find all neighbor pairs, store in neighbors matrix
	alloccmat( *neighbors, ntax, ngen);
	allocimat( *codes, ntax, ntax);
	for(i=0; i< ngen; i++){
		for(j=0; j< ntax; j++){
			// initialize
			neighbors.x[j][i].pred=-1;neighbors.x[j][i].succ=-1;

			// construct neighbor-pair codes (== states)
			for(k=0; k< ngen; k++){
				if(data.x[j][k]==i+1){	//genes are coded from base 1, 0 means absence



					// if begining
					if(k=0)
						m=0;	// code of chromosome beginning
					else	

					// if end
					if(k=ngen)
						n=ngen+1;	// code of chromosome end
					else
					// upper triangular only
					if(data.x[j][k-1] < data.x[j][k+1])
						m=data.x[j][k-1];  n=data.x[j][k+1];  
					else
						m=data.x[j][k-1];  n=data.x[j][k+1];  

					neighbors.x[j][i].pred=m;
					neighbors.x[j][i].succ=n;
				}
			}
		}
	}

	npos = ngen+2	// because we need to code beginning and end of chromosome, too
	allocimat( *coding, ngen, npos);
	for(i=0; i< ngen; i++){
	// for every gene
	for(i=0; i< ngen; i++){
		// initialize
		for(j=0; j< npos; j++)
			for(k=0; k< ngen; k++)
				coding.x[i][k]=0;
		count=0;
		// construct status codes
		for(j=0; j< tax; j++)
			if(neighbors.x[j][i].pred!=-1)	coding.x[i][j]=count++;

		// code status
		for(j=0; j< tax; j++){
			m=neighbors.x[j][i].pred;
			n=neighbors.x[j][i].succ;
			state.x[j][i]=coding.x[m][n];
		}


	// extract polarity
	allocimat( *polarity, ntax, ngen);
	for(i=0; i< ntax; i++)
		for(j=0; j< ngen; j++)
			if(data.x[i][j]==0) polarity.x[i][j]=0;
			else if(data.x[i][j]>0) polarity.x[i][j]=1; else polarity.x[i][j]-1;


	// count absent genes
	count=0;
	for(i=0; i< ngen; i++){	// for every gene
		ishole=1
		for(j=0; j<ntax ; j++)	// determine whether present in all taxa
			for(k=0; k<ngen ; k++)
				if(data.x[j][k]==i+1) ishole=0;
		if(ishole) count++;
	}



	// extract presence
	allocimat( *presence, ntax, count);
	count=0;
	for(i=0; i< ngen; i++){	// for every gene
		ishole=1
		for(j=0; j<ntax ; j++)	// determine whether present in all taxa
			for(k=0; k<gen ; k++)
				if(data.x[j][k]==i+1) ishole=0;
		if(ishole) 
			for(j=0; j<ntax ; j++)	// for every taxon
				for(k=0; k<gen ; k++)// find out whether this gene is present
					if(data.x[j][k]==i+1) 
						presence.x[j][i]=1;
					else
						presence.x[j][i]=0;

	}	// for i

...

	// write out coded character state matrix
	for(i=0; i< ntax; i++){	// for every taxon
		ishole=1
		for(j=0; j<state.cols ; j++)	// write out state
			printf("%d ", state[i][j];
		for(j=0; j<polarity.cols ; j++)	// write out polarity
			printf("%d ", polarity[i][j];
		for(j=0; j<presence.cols ; j++)	// write out presence
			printf("%d ", presence[i][j];
		printf("\n";
	}
}	// end
