/*
vector.c

matrix manipulation library
functions on vectors
version 0.03
Peter A. Cejchan, GPL
Mon Mar 29 12:51:07 EST 2004 <cej@gli.cas.cz | pac7@post.cz | pac@plan9.cz>


*/


#include <u.h>
#include <libc.h>
#include <bio.h>
#include <ctype.h>
#include "libmatrix.h" 
#include "vector.h" 


// functions:

int 
vec_read(Vector *vec)
// read whitespace-delimited vector
{
	Biobuf bin;
	char *buf, *av[MAXLENGTH];
	int i, j;

	Binit(&bin, 0, OREAD);
	i=0;
	if((buf = Brdstr(&bin, '\n', 1)) != nil){
		vec->len=   tokenize(buf, av, MAXLENGTH);
		for(j=0; j<vec->len; j++){
			vec->x[j]=atof(av[j]);
		}
		free(buf);
	}
	return 1;
}


Vector *
vec_alloc(int len)
// allocates memory for a vector
{
	int i,j;
	Vector *V;

	V=(Vector*)malloc(sizeof(Vector));
	V->len=len; 
	V->x=(double*)malloc(V->len*sizeof(double));
	for(i=0;i<V->len;i++)
		V->x[i]=0.0;
	return V;
}


void 
vec_write(Vector *V)
// write out a vector
{
	int i;
	print("%d ", V->len);
	for(i=0; i<V->len; i++){
		print("%f ", V->x[i]);
	}
	print("\n");
	return;
}


int 
vec_max(Vector *V)
//prints out col index of first occurrence of max value
{
	int i, maxi;
	double maxx;
	maxx = -MAXFLOAT;
	for(i=0; i<V->len; i++){
		if(V->x[i] > maxx) {
			maxx = V->x[i];
			maxi = i;
		}
	}
	print("%d\n", maxi);
	return 1;
}

double 
vec_scalar_prod(Vector *v1,Vector *v2)
// SUM[ v1i*v2i ]
{
  int i;
  double sum = 0;

  for(i=0; i<v1->len; i++)
     sum += v1->x[i]*v2->x[i];
  return sum;
}


